﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.EasyOpc.AlarmsAndEvents.AddressSpace;
using OpcLabs.EasyOpc.AlarmsAndEvents.OperationModel;

namespace WindowsFormsAppTestOPC
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        EasyAENotificationEventArgs _first;
        int _handle;

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            easyAEClient1 = new OpcLabs.EasyOpc.AlarmsAndEvents.EasyAEClient();
            easyAEClient1.Notification += new OpcLabs.EasyOpc.AlarmsAndEvents.EasyAENotificationEventHandler(EasyAEClient1_Notification);
            buttonCreate.BackColor = Color.YellowGreen;
        }

        private void EasyAEClient1_Notification(object sender, EasyAENotificationEventArgs e)
        {
            if (!e.Succeeded)
            {

            }

            if (e.EventData != null)
            {
                if (_first == null)
                    _first = e;
                ListBox1.Items.Add(string.Format("Condition Name= '{0}'    Src= '{1}' ", e.EventData.QualifiedSourceName, e.EventData.ConditionName));
            }
        }

        private void buttonSubscrite_Click(object sender, EventArgs e)
        {
            if (easyAEClient1 == null)
                return;

            string ip = textBoxAdresse.Text;
            string server =textBoxOPCServer.Text;
            int rate = int.Parse(textBoxRate.Text);

            _handle = easyAEClient1.SubscribeEvents(ip, server, rate);
            easyAEClient1.RefreshEventSubscription(_handle);
            buttonSubscite.BackColor = Color.YellowGreen;
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            ListBox1.Items.Clear();
        }

        private void buttonAct_Click(object sender, EventArgs e)
        {
            if (_first != null)
            {
                try
                {
                    string ip = textBoxAdresse.Text;
                    string server = textBoxOPCServer.Text;
                    AEEventData data = _first.EventData;
                    easyAEClient1.AcknowledgeCondition(ip, server, data.QualifiedSourceName,data.ConditionName, data.ActiveTime,data.Cookie);
                    MessageBox.Show("Succes");
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }
    }
}
